import MyValidator from "../../utils/myValidator";
let validatorInstance:MyValidator;
const app = getApp<IAppOption>();
Page({
  data: {
    Telephone:'',
    Street:'',
    LinkMan:'',
    Seq:'',
    location: {} as any,
  },
  async onLoad(options) {
    console.log(app);
    let seq = options.seq;
    if (seq != undefined) {
      console.log('seq',options);
      this.setData({
        Seq:options.seq
      })
      await this.getAddressDetails(seq);
    }

  },
  onReady() {
    this.initValidator()
  },
  onShow() {

  },
  async getAddressDetails(paymentaddress:string) {
     let [error, result] = await wx.$utils.to(
       wx.$http.request({
         url:`/shopping/address.do?m=getAddressDetail`,
         data: {
           paymentaddress
         }
       })
     )
     if (error){
       console.log(error);
       return;
     }
     console.log(result);
     this.setData({
        ...result.list,
       [`location.address`]:result.list.Address,
       [`location.name`]:result.list.AddressName,
       [`location.longitude`]:result.list.Longitude,
       [`location.latitude`]:result.list.Latitude,

     })
  },

  //从微信读取
  readFromWx() {
    wx.chooseAddress({
      success:(res)=> {
        console.log(res);
        let LinkMan = res.userName;
        let Street = res.detailInfo;
        let Telephone = res.telNumber;
        //
        this.setData({
          LinkMan,
          Telephone,
          Street
        });
      }
    })
  },

  getLocation(e:any){
    // console.log('获取到地址定位',e);
    this.setData({
      location:e.detail
    })
  },

  checkLinkMan(e:any){
    let { value } = e.detail
    console.log(e);
    validatorInstance.checkField('LinkMan',value);
  },
  checkTelephone(e:any){
    let { value } = e.detail
    console.log(e);
    validatorInstance.checkField('Telephone',value);
  },
  checkStreet(e:any){
    let { value } = e.detail
    console.log(e);
    validatorInstance.checkField('Street',value);
  },
  // checkField(type: string,value: string){
  //   validatorInstance.checkField(type,value);
  // },
  onSave() {
    if (!this.data.Seq) {
      let locationComponent = this.selectComponent('#location-plugin');
      let location = locationComponent.getLocation();
      if (!location) return;
      this.setData({location});
    }

    if (validatorInstance.checkAllData()){
      console.log('....提交订单成功');
      this.saveAddress();
    } else {
      console.log('还有错误未处理');
    }

  },
  async saveAddress() {
    let ac = 'new';
    if (this.data.Seq){
      ac = 'edit';
    }
    let data = {
      paymentAddress:this.data.Seq,
      ac,
      linkMan:this.data.LinkMan,
      telephone:this.data.Telephone,
      street:this.data.Street,
      addressName:this.data.location.name,
      address:this.data.location.address,
      longitude:this.data.location.longitude,
      latitude:this.data.location.latitude,
    }
    console.log('data',data);
    let [error, result] = await wx.$utils.to(
      wx.$http.request({
        url:`/shopping/address.do?m=updateAddress`,
        data: data,
        method:'POST'
      })
    )
    if (error){
      console.log(error);
      return;
    }
    console.log(result);
    wx.navigateBack();
  },
   onDelete() {
     wx.pro.showModal({
       title: '提示',
       content: '确定要删除该地址吗？',
     }).then((res:any) => {
       // on close
       console.log(res);
       if (res.confirm){
         console.log('确认');
         this.deleteAddress();
       }
     });
  },
  async deleteAddress() {
    let [error, result] = await wx.$utils.to(
      wx.$http.request({
        url:`/shopping/address.do?m=delAddress`,
        data: {
          paymentaddress:this.data.Seq,
        },
      })
    )
    if (error){
      console.log(error);
      return;
    }
    console.log(result);
    wx.navigateBack();
  },

  // validatorInstance(){},
  initValidator(){
    // 实例化
    validatorInstance = new MyValidator({
      rules: {
        LinkMan: {
          required: true,
          rangelength: [2, 32]
        },
        Telephone: {
          required: true,
          mobile: true,
        },
        Street: {
          required: true,
        },
      },
      messages: {
        LinkMan: {
          required: '请输入用户名',
          rangelength: '联系人姓名必须在2 至 32 字符之间！'
        },
        Telephone: {
          required: '请输入手机号',
          mobile: '手机号格式不正确'
        },
        Street: {
          required: '请输入街道地址'
        },
      },
      multiCheck:true
    },this)
  },
})
export {}
